//+------------------------------------------------------------------+
//|                           Currency_Loader.mq4                    |
//|                      Copyright  2006, Larionov P.V.             |
//|                                        lolion@mail.ru            |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Larionov P.V."
#property link      "lolion@mail.ru"
//---- input parameters
extern int  BarsMin=100;         //       .
extern int MaxBarsInFile = 50000; //  -    (  ).
extern int FrequencyUpdate = 200; //      .
extern bool LoadM1  = false;       //     .       
extern bool LoadM5  = true;      
extern bool LoadM15 = false;      
extern bool LoadM30 = false;       
extern bool LoadH1  = false;        
extern bool LoadH4  = false;
extern bool LoadD1  = false;
extern bool LoadW1  = false;
extern bool LoadMN  = false;
extern string UploadTF  = "H1"; //              
extern bool USRegionSet = false; //     
extern bool AllowInfo = True; //    
extern bool AllowLogFile = false; //     
extern bool LoadZeroBar  = false; //      0 .
extern bool BarEndTime  = false; //       1  .
extern bool Weekend = true; //        (  )   true       Start()
extern int  UploadTimes = 1; //      (  ),     
string ExpertName = "Currency_Loader V2.5";

int deinit(){return(0);}

double ArrayM1[][6], ArrayM5[][6], ArrayM15[][6], ArrayM30[][6], ArrayH1[][6],ArrayH4[][6], ArrayD1[][6], ArrayW1[][6], ArrayMN[][6]; 
int EndL=1, ct=0, iDigits, Tryes=5, Pause=500, ArrSizeM1, ArrSizeM5, ArrSizeM15, ArrSizeM30, ArrSizeH1, ArrSizeH4, ArrSizeD1, ArrSizeW1, ArrSizeMN, i, i2, i3, h1, h2, h3, h4, h5, h6, h7, h8, h9, LCM1, LCM5, LCM15, LCM30, LCH1, LCH4, LCD1, LCW1, LCMN, LastError;
string CString, x, x2, FileNameM1, FileNameM5, FileNameM15, FileNameM30, FileNameH1, FileNameH4, FileNameD1, FileNameW1, FileNameMN, FilePatch, FirstLine;
datetime BarTime;
 int MOM1,MOM2;
 double EMA1,EMA2,EMA3,EMA4;
 int JAD1;
 int Dstoh1,F,F1;
 int Dstoh2,Dstoh3,Dstoh4;
 int UU1,STD1,STD2;
 int UU2,P,VolM1,VolM2,VolM3,VolM4,VolM5;


int init(){//1
ct=0;
x="\"";
x2="\\";
if(LoadZeroBar){EndL=0;}else{EndL=1;}
iDigits=MarketInfo(Symbol(),MODE_DIGITS);
FilePatch = "Export_History"+x2+Symbol()+x2; 
if(UploadTF=="M1"){FileNameM1 = FilePatch+Symbol()+".csv";}else{FileNameM1 = FilePatch+Symbol()+"_"+"M1"+".csv";} //+"_"+"M1"
if(UploadTF=="M5"){FileNameM5 = FilePatch+Symbol()+".csv";}else{FileNameM5 = FilePatch+Symbol()+"_"+"M5"+".csv";} 
if(UploadTF=="M15"){FileNameM15 = FilePatch+Symbol()+".csv";}else{FileNameM15 = FilePatch+Symbol()+"_"+"M15"+".csv";} 
if(UploadTF=="M30"){FileNameM30 = FilePatch+Symbol()+".csv";}else{FileNameM30 = FilePatch+Symbol()+"_"+"M30"+".csv";}// 
if(UploadTF=="H1"){FileNameH1 = FilePatch+Symbol()+".csv";}else{FileNameH1 = FilePatch+Symbol()+"_"+"H1"+".csv"; }
if(UploadTF=="H4"){FileNameH4 = FilePatch+Symbol()+".csv";}else{FileNameH4 = FilePatch+Symbol()+"_"+"H4"+".csv";} 
if(UploadTF=="D1"){FileNameD1 = FilePatch+Symbol()+".csv";}else{FileNameD1 = FilePatch+Symbol()+"_"+"D1"+".csv";} 
if(UploadTF=="W1"){FileNameW1 = FilePatch+Symbol()+".csv";}else{FileNameW1 = FilePatch+Symbol()+"_"+"W1"+".csv";} 
if(UploadTF=="MN"){FileNameMN = FilePatch+Symbol()+".csv";}else{FileNameMN = FilePatch+Symbol()+"_"+"MN"+".csv";}
if(!USRegionSet){ 
//FirstLine =  ""+x+"Date"+x+";"+x+"Time"+x+";"+x+"CurSignal"+x+";"+x+"ProfitFactor"+x+";"+x+"Kelli"+x+";"+x+"Zscore"+x+";"+x+"H-MA"+x+";"+x+"L-MA"+x+";"+x+"Herst"+x+";"+x+"Dherst"+x+";"+x+"Metod"+x+";"+x+"TDsignal"+x+";"+x+"TDPOINT"+x+";"+x+"CCode"+x+";"+x+"Profit"+x;
FirstLine =  ""+x+"Date"+x+";"+x+"Time"+x+";"+x+"CurSignal"+x+";"+x+"Zscore"+x+";"+x+"MFI"+x+";"+x+"Stoh"+x+";"+x+"Herst"+x+";"+x+"Metod"+x+";"+x+"CCode"+x+";"+x+"Profit"+x+";"+x+"Loose"+x;
}else{
FirstLine =  ""+x+"Date"+x+";"+x+"Time"+x+";"+x+"CurSignal"+x+";"+x+"ProfitFactor"+x+";"+x+"Kelli"+x+";"+x+"Zscore"+x+";"+x+"H-MA"+x+";"+x+"L-MA"+x+";"+x+"TDsignal"+x+";"+x+"TDPOINT"+x+";"+x+"CCode"+x+";"+x+"Profit"+x;
}
//ct=CurTime()+FrequencyUpdate;
if (Weekend && UploadTimes>0){
for (int i=1; i<=UploadTimes; i++){
if(LoadM1){LoadingM1();Sleep(2000);}
if(LoadM5){LoadingM5();Sleep(2000);}
if(LoadM15){LoadingM15();Sleep(2000);}
if(LoadM30){LoadingM30();Sleep(2000);}
if(LoadH1){LoadingH1();Sleep(2000);}
if(LoadH4){LoadingH4();Sleep(2000);}
if(LoadD1){LoadingD1();Sleep(2000);}
if(LoadW1){LoadingW1();Sleep(2000);}
if(LoadMN){LoadingMN();Sleep(2000);}
}
}
return(0);
}



bool ROpen=false;

int start(){ //
//Comment(Time[1]);
if (Time[1]>14624412980){

if(LoadZeroBar){EndL=0;}else{EndL=1;}
if(ct == 0 || ct < StrToTime(TimeToStr(CurTime(),TIME_SECONDS))){ROpen=true;  ct=StrToTime(TimeToStr(CurTime()+FrequencyUpdate,TIME_SECONDS)); }
if(ROpen == true){//2
////////////////////////////////////////////////////////////////////////////// 
if(LoadM1){LoadingM1();Sleep(2000);}
if(LoadM5){LoadingM5();Sleep(2000);}
if(LoadM15){LoadingM15();Sleep(2000);}
if(LoadM30){LoadingM30();Sleep(2000);}
if(LoadH1){LoadingH1();Sleep(2000);}
if(LoadH4){LoadingH4();Sleep(2000);}
if(LoadD1){LoadingD1();Sleep(2000);}
if(LoadW1){LoadingW1();Sleep(2000);}
if(LoadMN){LoadingMN();Sleep(2000);}
ROpen=false;
////////////////////////////////////////////////////////////////////////////////
}//2 
}  
return(0);
}//1

//******************************************************************************************
// loading history data from M1
void LoadingM1(){//1
int MaxBars=MaxBarsInFile;
if(LoadM1 && iBars(Symbol(),PERIOD_M1)>BarsMin){ArrayCopyRates(ArrayM1,Symbol(),PERIOD_M1); ArrSizeM1=ArrayRange(ArrayM1,0);}
 if(ArrSizeM1>1){//2
 if(MaxBars>ArrSizeM1){MaxBars=ArrSizeM1;}
 if(BarEndTime){for(i=MaxBars-1;i>EndL;i--){ArrayM1[i][0]=ArrayM1[i-1][0];}
                ArrayM1[EndL][0]=ArrayM1[EndL][0]+(1*600);}
  for(i2=1; i2<=Tryes; i2++){//3
  h1 = FileOpen(FileNameM1,FILE_CSV|FILE_WRITE);
  if(h1==-1){LastError=GetLastError();
             Info("1.2",1,""," There is an error while opening file: "
             +FileNameM1+" at "+i2+" Try  "+ErrorDescription(LastError));
             Pause=Pause+Pause; Sleep(Pause); continue; }
       else{Info("1.2",2,"","File "+FileNameM1+" successfully opened ");} 
  FileWrite(h1,FirstLine);    
   for (i=MaxBars-1; i>=EndL; i-- ){//4
     BarTime=ArrayM1[i][0];
     if(BarEndTime){if(!(i==EndL))BarTime=ArrayM1[i-1][0];
                  else BarTime=ArrayM1[i][0]+(PERIOD_M1*60);} 
    if(!USRegionSet){
   CString=CString+TimeToStr(BarTime,TIME_DATE)+",";    //  date of bar
   CString=CString+TimeToStr(BarTime,TIME_MINUTES)+","; //  time of bar
   BarTime=0;
   }
   else{
   BarTime=ArrayM1[i][0];
   CString=CString+GetUSFormatTime(BarTime)+",";    //  date of bar
   BarTime=0;
   }
   CString=CString+DoubleToStr(ArrayM1[i][1],iDigits)+","; //  Open price
   CString=CString+DoubleToStr(ArrayM1[i][3],iDigits)+","; //  High price
   CString=CString+DoubleToStr(ArrayM1[i][2],iDigits)+","; //  Low price
   CString=CString+DoubleToStr(ArrayM1[i][4],iDigits)+","; //  Close price
   CString=CString+DoubleToStr(ArrayM1[i][5],0); //  Volume
   FileWrite(h1,CString);
   CString="";
   }//4
   FileClose(h1);
   LCM1 = iTime(Symbol(),PERIOD_M1,0);
   return;
  }//3
 }//2
}//1

void LoadingM5(){//1
int MaxBars=MaxBarsInFile,CLD,ECLD;
double StoH,Vol,CumDel,VOL1[],JVol,JCumDel,CumDel1,CumDel2,AD1;

if(LoadM5&&iBars(Symbol(),PERIOD_M5)>BarsMin){ArrayCopyRates(ArrayM5,Symbol(),PERIOD_M5); 
                                                 ArrSizeM5=ArrayRange(ArrayM5,0);}
 if(ArrSizeM5>1){//2
 if(MaxBars>ArrSizeM5){MaxBars=ArrSizeM5;}
  for(i2=1; i2<=Tryes; i2++){//3
  h2 = FileOpen(FileNameM5,FILE_CSV|FILE_WRITE);
  if(h2==-1){LastError=GetLastError();Info("1.2",1,""," There is an error while opening file: "+FileNameM5+" at "+i2+" Try  "+ErrorDescription(LastError));Pause=Pause+Pause; Sleep(Pause); continue; }else{Info("1.2",2,"","File "+FileNameM5+" successfully opened ");} 
  FileWrite(h2,FirstLine);
   for (i=MaxBars-1; i>=EndL; i-- ){//4
   double K=5,K1=8;
   double Signal=iCustom(NULL, 0, "TDSEQUENTA v2015",K,K1,12,6,i);
  // double VOL=iCustom(NULL, 0, "eVOLution-dvoid.1.3 (1)",1,i);
  // double OPN=iCustom(NULL, 0, "eVOLution-dvoid.1.3 (1)",2,i);
  // double DClose=iCustom(NULL, 0, "eVOLution-dvoid.1.3 (1)",3,i);

   if (((Signal!=0))){
   BarTime=ArrayM5[i][0];
   if(BarEndTime){if(!(i==EndL))BarTime=ArrayM5[i-1][0];
                  else BarTime=ArrayM5[i][0]+(PERIOD_M5*60);} 
   if(!USRegionSet){
   CString=CString+TimeToStr(BarTime,TIME_DATE)+";";    //  date of bar
   CString=CString+TimeToStr(BarTime,TIME_MINUTES)+";"; //  time of bar
   BarTime=0;
   }
   else{
    CString=CString+GetUSFormatTime(BarTime)+";";    //  date of bar
   BarTime=0;
   }
/*   
if (Signal>0){   
  MOM1=19;
  MOM2=18;
  Dstoh1=3;
  Dstoh2=12;
  Dstoh3=3;
  Dstoh4=11;
  EMA1=0.2;
  EMA2=0.5;
  EMA3=0.4;
  EMA4=0.05;
  STD1=18;
  STD2=17;
  F=15;
  F1=1;
   }
if (Signal<0){   
  MOM1=13;
  MOM2=14;
  Dstoh1=10;
  Dstoh2=10;
  Dstoh3=19;
  Dstoh4=5;
  EMA1=0.3;
  EMA2=0.9;
  EMA3=0.5;
  EMA4=0.02;
  STD1=7;
  STD2=11;
  F=6;
  F1=18;

   }   
 */
   
  double PONT=iCustom(NULL, 0, "TDSEQUENTA v2015",K,K1,12,5,i);
  if (PONT==1) PONT=2;
  double PONT1=iBullsPower(NULL,0,PONT,PRICE_CLOSE,i)+iBearsPower(NULL,0,PONT,PRICE_CLOSE,i);
  double MOM=iMomentum(NULL,0,PONT,PRICE_CLOSE,i);
  double Dstoh=iStochastic(NULL,0,PONT,PONT+9,PONT+9,MODE_EMA,0,MODE_MAIN,i);
  double STD=iStdDev(NULL,0,PONT,0,MODE_EMA,PRICE_CLOSE,i);
  double Force=iForce(NULL,0,PONT,MODE_EMA,PRICE_CLOSE,i);
  double VolM=iCustom(NULL, 0, "BetterVolume 1.4.1",9,i);
  double EMA=Close[i]-iCustom(NULL, 0, "9MAMA_NK",0.5,0.05,1,i);
  double Zscore=iCustom(NULL, 0, "TDSEQUENTA v2015",5,8,12,9,i);
  double Nstep=iCustom(NULL, 0, "TDSEQUENTA v2015",5,8,12,10,i);

/*
double MOMM=iCustom(NULL, 0, "SkyNet EasyMoneyGBPUSD_FirstLevel",1,i);
double DstohM=iCustom(NULL, 0, "SkyNet EasyMoneyGBPUSD_FirstLevel",2,i);
double PONT1M=iCustom(NULL, 0, "SkyNet EasyMoneyGBPUSD_FirstLevel",3,i);
double STDM=iCustom(NULL, 0, "SkyNet EasyMoneyGBPUSD_FirstLevel",4,i);
double ForceM=iCustom(NULL, 0, "SkyNet EasyMoneyGBPUSD_FirstLevel",5,i);
double VolMM=iCustom(NULL, 0, "SkyNet EasyMoneyGBPUSD_FirstLevel",6,i);



/*  
// double BVol=iCustom(NULL, 0, "BetterVolume 1.4.1",9,i);
 /*double Zscore=iCustom(NULL, 0, "TDSEQUENTA v2015",5,8,12,7,i);
 double DZscore=iCustom(NULL, 0, "TDSEQUENTA v2015",5,8,12,8,i);
 double DDZscore=iCustom(NULL, 0, "TDSEQUENTA v2015",5,8,12,9,i);
 double Kelli=iCustom(NULL, 0, "TDSEQUENTA v2015",5,8,12,12,i);
 double DKelli=iCustom(NULL, 0, "TDSEQUENTA v2015",5,8,12,13,i);
 double DDKelli=iCustom(NULL, 0, "TDSEQUENTA v2015",5,8,12,14,i);

  CString=CString+DoubleToStr(Zscore,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(DZscore,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(DDZscore,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(Kelli,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(DKelli,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(DDKelli,iDigits)+";"; //   Kelli
*/

  CString=CString+DoubleToStr(Signal,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(MOM,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(Dstoh,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(PONT1,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(STD,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(Force,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(VolM,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(EMA,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(Zscore,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(Nstep,iDigits)+";"; //   Kelli

 // CString=CString+DoubleToStr(Signal,iDigits)+";"; //   Kelli
 /* CString=CString+DoubleToStr(MOMM,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(DstohM,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(PONT1M,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(STDM,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(ForceM,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(VolMM,iDigits)+";"; //   Kelli
/* 
  CString=CString+DoubleToStr(Signal,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(Open[i],iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(Close[i],iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(High[i],iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(Low[i],iDigits)+";"; //   Kelli
//  CString=CString+DoubleToStr(Force,iDigits)+";"; //   Kelli
//  CString=CString+DoubleToStr(VolM,iDigits)+";"; //   Kelli
 /*
VolM1=iCustom( "USDCHF",0, "TDSEQUENTA v2015",5,8,12,7,i);
VolM2=iCustom( "USDJPY",0, "TDSEQUENTA v2015",5,8,12,7,i);
VolM3=iCustom( "EURGBP",0, "TDSEQUENTA v2015",5,8,12,7,i);
VolM4=iCustom( "EURUSD",0, "TDSEQUENTA v2015",5,8,12,7,i);
VolM5=iCustom( "GBPCHF",0, "TDSEQUENTA v2015",5,8,12,7,i);
*//*
VolM1=iCustom("USDCHF", 0, "BetterVolume 1.4.1",9,i);
VolM2=iCustom("USDJPY", 0, "BetterVolume 1.4.1",9,i);
VolM3=iCustom("EURGBP", 0, "BetterVolume 1.4.1",9,i);
VolM4=iCustom("EURUSD", 0, "BetterVolume 1.4.1",9,i);
VolM5=iCustom("GBPCHF", 0, "BetterVolume 1.4.1",9,i);
  double VolM=iCustom("NZDJPY", 0, "BetterVolume 1.4.1",9,i);

  CString=CString+DoubleToStr(Signal,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(VolM1,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(VolM2,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(VolM3,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(VolM4,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(VolM5,iDigits)+";"; //   Kelli
  CString=CString+DoubleToStr(VolM,iDigits)+";"; //   Kelli
 */
  //CString=CString+DoubleToStr(iVar,iDigits)+";"; //   Kelli
  //CString=CString+DoubleToStr(CC,iDigits)+";"; //   Kelli
 // CString=CString+DoubleToStr(UU,iDigits)+";"; //   Kelli
 // CString=CString+DoubleToStr(BVol,iDigits)+";"; //   Kelli
 // CString=CString+DoubleToStr(Zscore,iDigits)+";"; //   Kelli
 // CString=CString+DoubleToStr(Sig15,iDigits)+";"; //   Kelli

   CString=CString+DoubleToStr(iCustom(NULL, 0, "TDSEQUENTA v2015",K,K1,12,1,i),iDigits)+";"; //  Exit;
  // CString=CString+DoubleToStr(iCustom(NULL, 0, "TDSEQUENTA v2015",K,K1,12,0,i),iDigits)+";"; //  Exit;
  // CString=CString+DoubleToStr(iCustom(NULL, 0, "SkyNet EasyMoneyGBP_1",1,i),iDigits)+";"; //  Exit;
  // CString=CString+DoubleToStr(iCustom(NULL, 0, "SkyNet EasyMoney",2,i),iDigits)+";"; //  Exit;
 
   FileWrite(h2,CString);
   CString="";
 }
    }//4
   FileClose(h2);
   LCM5 = iTime(Symbol(),PERIOD_M5,0);
   return;
  }//3
 }//2
}//1

//******************************************************************************************
//loading history data from M15
void LoadingM15(){//1
int MaxBars=MaxBarsInFile;
if(LoadM15 && iBars(Symbol(),PERIOD_M15)>BarsMin){ArrayCopyRates(ArrayM15,Symbol(),PERIOD_M15); ArrSizeM15=ArrayRange(ArrayM15,0);}
if(ArrSizeM15>1){//2
 if(MaxBars>ArrSizeM15){MaxBars=ArrSizeM15;}
  for(i2=1; i2<=Tryes; i2++){//3
  h3 = FileOpen(FileNameM15,FILE_CSV|FILE_WRITE);
  if(h3==-1){LastError=GetLastError();Info("1.2",1,""," There is an error while opening file: "+FileNameM15+" at "+i2+" Try  "+ErrorDescription(LastError));Pause=Pause+Pause; Sleep(Pause); continue; }else{Info("1.2",2,"","File "+FileNameM15+" successfully opened ");} 
  FileWrite(h3,FirstLine);
   for (i=MaxBars-1; i>=EndL; i-- ){//4
   BarTime=ArrayM15[i][0];
   if(BarEndTime){if(!(i==EndL))BarTime=ArrayM15[i-1][0];
                  else BarTime=ArrayM15[i][0]+(PERIOD_M15*60);} 
   if(!USRegionSet){
   CString=CString+TimeToStr(ArrayM15[i][0],TIME_DATE)+",";    //  date of bar
   CString=CString+TimeToStr(ArrayM15[i][0],TIME_MINUTES)+","; //  time of bar
   BarTime=0;
   }
   else{
   CString=CString+GetUSFormatTime(BarTime)+",";    //  date of bar
   BarTime=0;
   }
   CString=CString+DoubleToStr(ArrayM15[i][1],iDigits)+","; //  Open price
   CString=CString+DoubleToStr(ArrayM15[i][3],iDigits)+","; //  High price
   CString=CString+DoubleToStr(ArrayM15[i][2],iDigits)+","; //  Low price
   CString=CString+DoubleToStr(ArrayM15[i][4],iDigits)+","; //  Close price
   CString=CString+DoubleToStr(ArrayM15[i][5],0); //  Volume
   FileWrite(h3,CString);
   CString="";
   }//4
   FileClose(h3);
   LCM15 = iTime(Symbol(),PERIOD_M15,0);
   return;
  }//3
 }//2
}//1

//******************************************************************************************
//loading history data from M30
void LoadingM30(){//1
int MaxBars=MaxBarsInFile;
if(LoadM30 && iBars(Symbol(),PERIOD_M30)>BarsMin){ArrayCopyRates(ArrayM30,Symbol(),PERIOD_M30); ArrSizeM30=ArrayRange(ArrayM30,0);}
if(ArrSizeM30>1){//2
 if(MaxBars>ArrSizeM30){MaxBars=ArrSizeM30;}
  for(i2=1; i2<=Tryes; i2++){//3
  h4 = FileOpen(FileNameM30,FILE_CSV|FILE_WRITE);
  if(h4==-1){LastError=GetLastError();Info("1.2",1,""," There is an error while opening file: "+FileNameM30+" at "+i2+" Try  "+ErrorDescription(LastError));Pause=Pause+Pause; Sleep(Pause); continue; }else{Info("1.2",2,"","File "+FileNameM30+" successfully opened ");} 
  FileWrite(h4,FirstLine);
   for (i=MaxBars-1; i>=EndL; i-- ){//4
   BarTime=ArrayM30[i][0];
   if(BarEndTime){if(!(i==EndL))BarTime=ArrayM30[i-1][0];
                  else BarTime=ArrayM30[i][0]+(PERIOD_M30*60);} 
   if(!USRegionSet){
   CString=CString+TimeToStr(ArrayM30[i][0],TIME_DATE)+",";    //  date of bar
   CString=CString+TimeToStr(ArrayM30[i][0],TIME_MINUTES)+","; //  time of bar
   BarTime=0;
   }
   else{
   CString=CString+GetUSFormatTime(BarTime)+",";    //  date of bar
   BarTime=0;
   }
   CString=CString+DoubleToStr(ArrayM30[i][1],iDigits)+","; //  Open price
   CString=CString+DoubleToStr(ArrayM30[i][3],iDigits)+","; //  High price
   CString=CString+DoubleToStr(ArrayM30[i][2],iDigits)+","; //  Low price
   CString=CString+DoubleToStr(ArrayM30[i][4],iDigits)+","; //  Close price
   CString=CString+DoubleToStr(ArrayM30[i][5],0); //  Volume
   FileWrite(h4,CString);
   CString="";
   }//4
   FileClose(h4);
   LCM30 = iTime(Symbol(),PERIOD_M30,0);
   return;
  }//3
 }//2
}//1

//******************************************************************************************
//loading history data from H1
void LoadingH1(){//1
int MaxBars=MaxBarsInFile;
if(LoadH1 && iBars(Symbol(),PERIOD_H1)>BarsMin){ArrayCopyRates(ArrayH1,Symbol(),PERIOD_H1); ArrSizeH1=ArrayRange(ArrayH1,0);}
if(ArrSizeH1>1){//2
 if(MaxBars>ArrSizeH1){MaxBars=ArrSizeH1;}
  for(i2=1; i2<=Tryes; i2++){//3
  h5 = FileOpen(FileNameH1,FILE_CSV|FILE_WRITE);
  if(h5==-1){LastError=GetLastError();Info("1.2",1,""," There is an error while opening file: "+FileNameH1+" at "+i2+" Try  "+ErrorDescription(LastError));Pause=Pause+Pause; Sleep(Pause); continue; }else{Info("1.2",2,"","File "+FileNameH1+" successfully opened ");} 
  FileWrite(h5,FirstLine);
   for (i=MaxBars-1; i>=EndL; i-- ){//4
   BarTime=ArrayH1[i][0];
   if(BarEndTime){if(!(i==EndL))BarTime=ArrayH1[i-1][0];
                  else BarTime=ArrayH1[i][0]+(PERIOD_H1*60);} 
   if(!USRegionSet){
   CString=CString+TimeToStr(ArrayH1[i][0],TIME_DATE)+",";    //  date of bar
   CString=CString+TimeToStr(ArrayH1[i][0],TIME_MINUTES)+","; //  time of bar
   BarTime=0;
   }
   else{
   CString=CString+GetUSFormatTime(BarTime)+",";    //  date of bar
   BarTime=0;
   }
   CString=CString+DoubleToStr(ArrayH1[i][1],iDigits)+","; //  Open price
   CString=CString+DoubleToStr(ArrayH1[i][3],iDigits)+","; //  High price
   CString=CString+DoubleToStr(ArrayH1[i][2],iDigits)+","; //  Low price
   CString=CString+DoubleToStr(ArrayH1[i][4],iDigits)+","; //  Close price
   CString=CString+DoubleToStr(ArrayH1[i][5],0); //  Volume
   FileWrite(h5,CString);
   CString="";
   }//4
   FileClose(h5);
   LCH1 = iTime(Symbol(),PERIOD_H1,0);
   return;
  }//3
 }//2
}//1

//******************************************************************************************
//loading history data from H4
void LoadingH4(){//1
int MaxBars=MaxBarsInFile;
if(LoadH4 && iBars(Symbol(),PERIOD_H4)>BarsMin){ArrayCopyRates(ArrayH4,Symbol(),PERIOD_H4); ArrSizeH4=ArrayRange(ArrayH4,0);}
if(ArrSizeH4>1){//2
 if(MaxBars>ArrSizeH4){MaxBars=ArrSizeH4;}
  for(i2=1; i2<=Tryes; i2++){//3
  h6 = FileOpen(FileNameH4,FILE_CSV|FILE_WRITE);
  if(h6==-1){LastError=GetLastError();Info("1.2",1,""," There is an error while opening file: "+FileNameH4+" at "+i2+" Try  "+ErrorDescription(LastError));Pause=Pause+Pause; Sleep(Pause); continue; }else{Info("1.2",2,"","File "+FileNameH4+" successfully opened ");} 
  FileWrite(h6,FirstLine);
   for (i=MaxBars-1; i>=EndL; i-- ){//4 
   BarTime=ArrayH4[i][0];
   if(BarEndTime){if(!(i==EndL))BarTime=ArrayH4[i-1][0];
                  else BarTime=ArrayH4[i][0]+(PERIOD_H4*60);} 
   if(!USRegionSet){
   CString=CString+TimeToStr(ArrayH4[i][0],TIME_DATE)+",";    //  date of bar
   CString=CString+TimeToStr(ArrayH4[i][0],TIME_MINUTES)+","; //  time of bar
   BarTime=0;
   }
   else{
   CString=CString+GetUSFormatTime(BarTime)+",";    //  date of bar
   BarTime=0;
   }
   CString=CString+DoubleToStr(ArrayH4[i][1],iDigits)+","; //  Open price
   CString=CString+DoubleToStr(ArrayH4[i][3],iDigits)+","; //  High price
   CString=CString+DoubleToStr(ArrayH4[i][2],iDigits)+","; //  Low price
   CString=CString+DoubleToStr(ArrayH4[i][4],iDigits)+","; //  Close price
   CString=CString+DoubleToStr(ArrayH4[i][5],0); //  Volume
   FileWrite(h6,CString);
   CString="";
   }//4
   FileClose(h6);
   LCH4 = iTime(Symbol(),PERIOD_H4,0);
   return;
  }//3
 }//2
}//1

//******************************************************************************************
//loading history data from D1
void LoadingD1(){//1
int MaxBars=MaxBarsInFile;
if(LoadD1 && iBars(Symbol(),PERIOD_D1)>BarsMin){ArrayCopyRates(ArrayD1,Symbol(),PERIOD_D1); ArrSizeD1=ArrayRange(ArrayD1,0);}
if(ArrSizeD1>1){//2
 if(MaxBars>ArrSizeD1){MaxBars=ArrSizeD1;}
  for(i2=1; i2<=Tryes; i2++){//3
  h7 = FileOpen(FileNameD1,FILE_CSV|FILE_WRITE);
  if(h7==-1){LastError=GetLastError();Info("1.2",1,""," There is an error while opening file: "+FileNameD1+" at "+i2+" Try  "+ErrorDescription(LastError));Pause=Pause+Pause; Sleep(Pause); continue; }else{Info("1.2",2,"","File "+FileNameD1+" successfully opened ");} 
  FileWrite(h7,FirstLine);
   for (i=MaxBars-1; i>=EndL; i-- ){//4 
   BarTime=ArrayD1[i][0];
   if(BarEndTime){if(!(i==EndL))BarTime=ArrayD1[i-1][0];
                  else BarTime=ArrayD1[i][0]+(PERIOD_D1*60);} 
   if(!USRegionSet){
   CString=CString+TimeToStr(ArrayD1[i][0],TIME_DATE)+",";    //  date of bar
   CString=CString+TimeToStr(ArrayD1[i][0],TIME_MINUTES)+","; //  time of bar
   BarTime=0;
   }
   else{
   CString=CString+GetUSFormatTime(BarTime)+",";    //  date of bar
   BarTime=0;
   }
   CString=CString+DoubleToStr(ArrayD1[i][1],iDigits)+","; //  Open price
   CString=CString+DoubleToStr(ArrayD1[i][3],iDigits)+","; //  High price
   CString=CString+DoubleToStr(ArrayD1[i][2],iDigits)+","; //  Low price
   CString=CString+DoubleToStr(ArrayD1[i][4],iDigits)+","; //  Close price
   CString=CString+DoubleToStr(ArrayD1[i][5],0); //  Volume
   FileWrite(h7,CString);
   CString="";
   }//4
   FileClose(h7);
   LCD1 = iTime(Symbol(),PERIOD_D1,0);
   return;
  }//3
 }//2
}//1

//******************************************************************************************
//loading history data from W1
void LoadingW1(){//1
int MaxBars=MaxBarsInFile;
if(LoadW1 && iBars(Symbol(),PERIOD_W1)>BarsMin){ArrayCopyRates(ArrayW1,Symbol(),PERIOD_W1); ArrSizeW1=ArrayRange(ArrayW1,0);}
if(ArrSizeW1>1){//2
 if(MaxBars>ArrSizeW1){MaxBars=ArrSizeW1;}
  for(i2=1; i2<=Tryes; i2++){//3
  h8 = FileOpen(FileNameW1,FILE_CSV|FILE_WRITE);
  if(h8==-1){LastError=GetLastError();Info("1.2",1,""," There is an error while opening file: "+FileNameW1+" at "+i2+" Try  "+ErrorDescription(LastError));Pause=Pause+Pause; Sleep(Pause); continue; }else{Info("1.2",2,"","File "+FileNameW1+" successfully opened ");} 
  FileWrite(h8,FirstLine);
   for (i=MaxBars-1; i>=EndL; i-- ){//4 
   BarTime=ArrayW1[i][0];
   if(BarEndTime){if(!(i==EndL))BarTime=ArrayW1[i-1][0];
                  else BarTime=ArrayW1[i][0]+(PERIOD_W1*60);} 
   if(!USRegionSet){
   CString=CString+TimeToStr(ArrayW1[i][0],TIME_DATE)+",";    //  date of bar
   CString=CString+TimeToStr(ArrayW1[i][0],TIME_MINUTES)+","; //  time of bar
   BarTime=0;
   }
   else{
   CString=CString+GetUSFormatTime(BarTime)+",";    //  date of bar
   BarTime=0;
   }
   CString=CString+DoubleToStr(ArrayW1[i][1],iDigits)+","; //  Open price
   CString=CString+DoubleToStr(ArrayW1[i][3],iDigits)+","; //  High price
   CString=CString+DoubleToStr(ArrayW1[i][2],iDigits)+","; //  Low price
   CString=CString+DoubleToStr(ArrayW1[i][4],iDigits)+","; //  Close price
   CString=CString+DoubleToStr(ArrayW1[i][5],0); //  Volume
   FileWrite(h8,CString);
   CString="";
   }//4
   FileClose(h8);
   LCW1 = iTime(Symbol(),PERIOD_W1,0);
   return;
  }//3
 }//2
}//1

//******************************************************************************************
//loading history data from MN1
void LoadingMN(){//1
int MaxBars=MaxBarsInFile;
if(LoadMN && iBars(Symbol(),PERIOD_MN1)>BarsMin){ArrayCopyRates(ArrayMN,Symbol(),PERIOD_MN1); ArrSizeMN=ArrayRange(ArrayMN,0);}
if(ArrSizeMN>1){//2
 if(MaxBars>ArrSizeMN){MaxBars=ArrSizeMN;}
  for(i2=1; i2<=Tryes; i2++){//3
  h9 = FileOpen(FileNameMN,FILE_CSV|FILE_WRITE);
  if(h9==-1){LastError=GetLastError();Info("1.2",1,""," There is an error while opening file: "+FileNameMN+" at "+i2+" Try  "+ErrorDescription(LastError));Pause=Pause+Pause; Sleep(Pause); continue; }else{Info("1.2",2,"","File "+FileNameMN+" successfully opened ");} 
  FileWrite(h9,FirstLine);
   for (i=MaxBars-1; i>=EndL; i-- ){//4 
   BarTime=ArrayMN[i][0];
   if(BarEndTime){if(!(i==EndL))BarTime=ArrayMN[i-1][0];
                  else BarTime=ArrayMN[i][0]+(PERIOD_MN1*60);} 
   if(!USRegionSet){
   CString=CString+TimeToStr(ArrayMN[i][0],TIME_DATE)+",";    //  date of bar
   CString=CString+TimeToStr(ArrayMN[i][0],TIME_MINUTES)+","; //  time of bar
   BarTime=0;
   }
   else{
   CString=CString+GetUSFormatTime(BarTime)+",";    //  date of bar
   BarTime=0;
   }
   CString=CString+DoubleToStr(ArrayMN[i][1],iDigits)+","; //  Open price
   CString=CString+DoubleToStr(ArrayMN[i][3],iDigits)+","; //  High price
   CString=CString+DoubleToStr(ArrayMN[i][2],iDigits)+","; //  Low price
   CString=CString+DoubleToStr(ArrayMN[i][4],iDigits)+","; //  Close price
   CString=CString+DoubleToStr(ArrayMN[i][5],0); //  Volume
   FileWrite(h9,CString);
   CString="";
   }//4
   FileClose(h9);
   LCMN = iTime(Symbol(),PERIOD_MN1,0);
   return;
  }//3
 }//2
}//1

/************************************************************************************************
void Info(string MessageType=1, int Actuality=1, string MessageHead="", string MessageBody="HI")
:     , 
      , 
   ,      .
:
string MessageType - 1-  , 2-   , 3-   . 4-        .  
int Actuality  -   ,  1  5.
string MessageHead -     .
string MessageBody -  .  
***********************************************************************************************/
double Info(string MessageType="1,0,0", int Actuality = 1, string MessageHead="", string MessageBody="HI"){//1
int WarnMessLevel=3;
bool AllowMailSending=false, AllowStatement=false;
string _CurTimeDaily;
 string CurRusTimeMin;
 _CurTimeDaily = GetCurRusTime("Days"); 
 if(Actuality<=WarnMessLevel){//2
 int i, fwr;
 int OpString=-1;
 string FileName =StringConcatenate("LOG",ExpertName,_CurTimeDaily); 
 if(MessageHead=="")MessageHead=StringConcatenate("from expert ",ExpertName,TimeToStr(CurTime()));
 OpString = StringFind(MessageType,"1",0);
 if(OpString>-1){if(AllowInfo){Print(MessageBody);}}
 OpString = StringFind(MessageType,"2",0);
  if(OpString>-1){//3
   if(AllowLogFile){//4
    CurRusTimeMin = GetCurRusTime("Seconds")+" ";
    MessageBody= StringConcatenate(CurRusTimeMin,MessageBody); 
    for(i=0; i<5; i++){//5
    int HFile=FileOpen(FileName,FILE_READ|FILE_WRITE," "); 
     if(HFile>0){//6    
     FileSeek(HFile,0,SEEK_END); 
     FileWrite(HFile,MessageBody); 
     FileFlush(HFile); 
     FileClose(HFile);
     break; 
     }else{Sleep(500); continue; }//6
    }//5
   }//4
  }//3
  OpString = StringFind(MessageType,"3",0);
  if(OpString>-1){//3
   if(AllowMailSending && (!IsTesting())){//4
   int RetVal;
   SendMail( MessageHead, MessageBody );
   RetVal = GetLastError();
   if(RetVal>0){Info("1.2",1,"","Some mistakes were happened while mail sending "+ErrorDescription(RetVal));}
   }//4
  }//3
  OpString = StringFind(MessageType,"4",0);
  if(OpString>-1){//3
   if(AllowStatement){//4
   i=i;
   }//4
  }//3
 }else{return(0);}//2
return(0);
}//1

string GetUSFormatTime(int BTime){
string DateYear, DateMonth, DateDay, DateHour, DateMinutes, DateSeconds, TimeDays, TimeHoursMinutes;
string FormattedString="", AMPM="";
int LenghtDate, iHour;
TimeDays  = TimeToStr(BTime,TIME_DATE);
TimeHoursMinutes = TimeToStr(BTime,TIME_MINUTES|TIME_SECONDS);
LenghtDate = StringLen(TimeDays);
DateYear = StringSubstr(TimeDays,0,4);
DateMonth = StringSubstr(TimeDays,5,2);
DateDay = StringSubstr(TimeDays,8,2);
DateHour = StringSubstr(TimeHoursMinutes,0,2);
DateMinutes = StringSubstr(TimeHoursMinutes,3,2);
DateSeconds = StringSubstr(TimeHoursMinutes,6,2);
iHour=StrToInteger(DateHour);
switch(iHour){
case 0:AMPM="AM"; iHour=12; break;
case 1:AMPM="AM"; iHour=1; break;
case 2:AMPM="AM"; iHour=2; break;
case 3:AMPM="AM"; iHour=3; break;
case 4:AMPM="AM"; iHour=4; break;
case 5:AMPM="AM"; iHour=5; break;
case 6:AMPM="AM"; iHour=6; break;
case 7:AMPM="AM"; iHour=7; break;
case 8:AMPM="AM"; iHour=8; break;
case 9:AMPM="AM"; iHour=9; break;
case 10:AMPM="AM"; iHour=10; break;
case 11:AMPM="AM"; iHour=11; break;
case 12:AMPM="PM"; iHour=12; break;
case 13:AMPM="PM"; iHour=1; break;
case 14:AMPM="PM"; iHour=2; break;
case 15:AMPM="PM"; iHour=3; break;
case 16:AMPM="PM"; iHour=4; break;
case 17:AMPM="PM"; iHour=5; break;
case 18:AMPM="PM"; iHour=6; break;
case 19:AMPM="PM"; iHour=7; break;
case 20:AMPM="PM"; iHour=8; break;
case 21:AMPM="PM"; iHour=9; break;
case 22:AMPM="PM"; iHour=10; break;
case 23:AMPM="PM"; iHour=11; break;
default:AMPM="AM"; iHour=12; break;
}
FormattedString=StringConcatenate(DateYear,"/",DateMonth,"/",DateDay," ",iHour,":",DateMinutes,":",DateSeconds," ",AMPM);
return(FormattedString);
}

string GetCurRusTime(string Detail) 
{//1 
   string StrMonth="",StrDay="",StrHour="",StrMinute="",StrSeconds=""; 
   RefreshRates(); 
 
 if (Detail == "Seconds"){  
   if(Month()<10) { StrMonth="0"+Month(); } else { StrMonth=Month(); } 
   if(Day()<10) { StrDay="0"+Day(); } else { StrDay=Day(); } 
   if(Hour()<10) { StrHour="0"+Hour(); } else { StrHour=Hour(); } 
   if(Minute()<10) { StrMinute="0"+Minute(); } else { StrMinute=Minute(); } 
   if(Seconds()<10) { StrSeconds="0"+Seconds(); } else { StrSeconds=Seconds(); } 
   return(""+StrDay+"."+StrMonth+"."+Year()+" "+StrHour+":"+StrMinute+":"+StrSeconds+" ");  
   }
 if (Detail == "Hours"){  
   if(Month()<10) { StrMonth="0"+Month(); } else { StrMonth=Month(); } 
   if(Day()<10) { StrDay="0"+Day(); } else { StrDay=Day(); } 
   if(Hour()<10) { StrHour="0"+Hour(); } else { StrHour=Hour(); } 
   if(Minute()<10) { StrMinute="0"+Minute(); } else { StrMinute=Minute(); } 
   if(Seconds()<10) { StrSeconds="0"+Seconds(); } else { StrSeconds=Seconds(); } 
   return(""+StrDay+"."+StrMonth+"."+Year()+" "+StrHour+":00:"+"00 ");  
   }
 if (Detail == "Days"){  
   if(Month()<10) { StrMonth="0"+Month(); }else { StrMonth=Month(); } 
   if(Day()<10) { StrDay="0"+Day(); } else { StrDay=Day(); } 
   if(Hour()<10) { StrHour="0"+Hour(); } else { StrHour=Hour(); } 
   if(Minute()<10) { StrMinute="0"+Minute(); } else { StrMinute=Minute(); } 
   if(Seconds()<10) { StrSeconds="0"+Seconds(); } else { StrSeconds=Seconds(); } 
   return(""+StrDay+"."+StrMonth+"."+Year()+" ");  
   }
}//1 





//---- codes returned from trade server
string ErrorDescription(int error_code)
  {
   string error_string;
//----
   switch(error_code)
     {
      case 0:
      case 1:   error_string="no error";                                                  break;
      case 2:   error_string="common error";                                              break;
      case 3:   error_string="invalid trade parameters";                                  break;
      case 4:   error_string="trade server is busy";                                      break;
      case 5:   error_string="old version of the client terminal";                        break;
      case 6:   error_string="no connection with trade server";                           break;
      case 7:   error_string="not enough rights";                                         break;
      case 8:   error_string="too frequent requests";                                     break;
      case 9:   error_string="malfunctional trade operation";                             break;
      case 64:  error_string="account disabled";                                          break;
      case 65:  error_string="invalid account";                                           break;
      case 128: error_string="trade timeout";                                             break;
      case 129: error_string="invalid price";                                             break;
      case 130: error_string="invalid stops";                                             break;
      case 131: error_string="invalid trade volume";                                      break;
      case 132: error_string="market is closed";                                          break;
      case 133: error_string="trade is disabled";                                         break;
      case 134: error_string="not enough money";                                          break;
      case 135: error_string="price changed";                                             break;
      case 136: error_string="off quotes";                                                break;
      case 137: error_string="broker is busy";                                            break;
      case 138: error_string="requote";                                                   break;
      case 139: error_string="order is locked";                                           break;
      case 140: error_string="long positions only allowed";                               break;
      case 141: error_string="too many requests";                                         break;
      case 145: error_string="modification denied because order too close to market";     break;
      case 146: error_string="trade context is busy";                                     break;
      //---- mql4 errors
      case 4000: error_string="no error";                                                 break;
      case 4001: error_string="wrong function pointer";                                   break;
      case 4002: error_string="array index is out of range";                              break;
      case 4003: error_string="no memory for function call stack";                        break;
      case 4004: error_string="recursive stack overflow";                                 break;
      case 4005: error_string="not enough stack for parameter";                           break;
      case 4006: error_string="no memory for parameter string";                           break;
      case 4007: error_string="no memory for temp string";                                break;
      case 4008: error_string="not initialized string";                                   break;
      case 4009: error_string="not initialized string in array";                          break;
      case 4010: error_string="no memory for array\' string";                             break;
      case 4011: error_string="too long string";                                          break;
      case 4012: error_string="remainder from zero divide";                               break;
      case 4013: error_string="zero divide";                                              break;
      case 4014: error_string="unknown command";                                          break;
      case 4015: error_string="wrong jump (never generated error)";                       break;
      case 4016: error_string="not initialized array";                                    break;
      case 4017: error_string="dll calls are not allowed";                                break;
      case 4018: error_string="cannot load library";                                      break;
      case 4019: error_string="cannot call function";                                     break;
      case 4020: error_string="expert function calls are not allowed";                    break;
      case 4021: error_string="not enough memory for temp string returned from function"; break;
      case 4022: error_string="system is busy (never generated error)";                   break;
      case 4050: error_string="invalid function parameters count";                        break;
      case 4051: error_string="invalid function parameter value";                         break;
      case 4052: error_string="string function internal error";                           break;
      case 4053: error_string="some array error";                                         break;
      case 4054: error_string="incorrect series array using";                             break;
      case 4055: error_string="custom indicator error";                                   break;
      case 4056: error_string="arrays are incompatible";                                  break;
      case 4057: error_string="global variables processing error";                        break;
      case 4058: error_string="global variable not found";                                break;
      case 4059: error_string="function is not allowed in testing mode";                  break;
      case 4060: error_string="function is not confirmed";                                break;
      case 4061: error_string="send mail error";                                          break;
      case 4062: error_string="string parameter expected";                                break;
      case 4063: error_string="integer parameter expected";                               break;
      case 4064: error_string="double parameter expected";                                break;
      case 4065: error_string="array as parameter expected";                              break;
      case 4066: error_string="requested history data in update state";                   break;
      case 4099: error_string="end of file";                                              break;
      case 4100: error_string="some file error";                                          break;
      case 4101: error_string="wrong file name";                                          break;
      case 4102: error_string="too many opened files";                                    break;
      case 4103: error_string="cannot open file";                                         break;
      case 4104: error_string="incompatible access to a file";                            break;
      case 4105: error_string="no order selected";                                        break;
      case 4106: error_string="unknown symbol";                                           break;
      case 4107: error_string="invalid price parameter for trade function";               break;
      case 4108: error_string="invalid ticket";                                           break;
      case 4109: error_string="trade is not allowed";                                     break;
      case 4110: error_string="longs are not allowed";                                    break;
      case 4111: error_string="shorts are not allowed";                                   break;
      case 4200: error_string="object is already exist";                                  break;
      case 4201: error_string="unknown object property";                                  break;
      case 4202: error_string="object is not exist";                                      break;
      case 4203: error_string="unknown object type";                                      break;
      case 4204: error_string="no object name";                                           break;
      case 4205: error_string="object coordinates error";                                 break;
      case 4206: error_string="no specified subwindow";                                   break;
      default:   error_string="unknown error";
     }
//----
   return(error_string);
  }



